Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp	(revision 105819)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp	(revision 105820)
@@ -360,5 +360,5 @@
     pActionOpenExistingMedium->setData(QVariant::fromValue(UIMediumTarget(strControllerName, comCurrentAttachment.GetPort(),
                                                                           comCurrentAttachment.GetDevice(), enmMediumType)));
-    pActionOpenExistingMedium->setText(QApplication::translate("UIMediumTools", "Choose/Create a disk image..."));
+    pActionOpenExistingMedium->setText(QApplication::translate("UIMediumTools", "Choose/Create a Disk Image..."));
 
     /* Prepare open medium file action: */
@@ -368,5 +368,5 @@
                                                                     comCurrentAttachment.GetDevice(), enmMediumType,
                                                                     UIMediumTarget::UIMediumTargetType_WithFileDialog)));
-    pActionFileSelector->setText(QApplication::translate("UIStorageSettingsEditor", "Choose a disk file..."));
+    pActionFileSelector->setText(QApplication::translate("UIMediumTools", "Choose a Disk File..."));
 
     /* Insert separator: */
@@ -481,5 +481,5 @@
         pActionUnmountMedium->setData(QVariant::fromValue(UIMediumTarget(strControllerName, comCurrentAttachment.GetPort(),
                                                                          comCurrentAttachment.GetDevice())));
-        pActionUnmountMedium->setText(QApplication::translate("UIStorageSettingsEditor", "Remove disk from virtual drive"));
+        pActionUnmountMedium->setText(QApplication::translate("UIMediumTools", "Remove Disk From Virtual Drive"));
         if (enmMediumType == UIMediumDeviceType_DVD)
             pActionUnmountMedium->setIcon(UIIconPool::iconSet(":/cd_unmount_16px.png", ":/cd_unmount_disabled_16px.png"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp	(revision 105819)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp	(revision 105820)
@@ -3848,5 +3848,5 @@
                 /* Add "Choose a virtual hard disk" action: */
                 addChooseExistingMediumAction(pOpenMediumMenu, tr("Choose/Create a Virtual Hard Disk..."));
-                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a disk file..."));
+                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a Disk File..."));
                 pOpenMediumMenu->addSeparator();
                 /* Add recent media list: */
@@ -3858,5 +3858,5 @@
                 /* Add "Choose a virtual optical disk" action: */
                 addChooseExistingMediumAction(pOpenMediumMenu, tr("Choose/Create a Virtual Optical Disk..."));
-                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a disk file..."));
+                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a Disk File..."));
                 /* Add "Choose a physical drive" actions: */
                 addChooseHostDriveActions(pOpenMediumMenu);
@@ -3866,5 +3866,5 @@
                 /* Add "Eject current medium" action: */
                 pOpenMediumMenu->addSeparator();
-                QAction *pEjectCurrentMedium = pOpenMediumMenu->addAction(tr("Remove Disk from Virtual Drive"));
+                QAction *pEjectCurrentMedium = pOpenMediumMenu->addAction(tr("Remove Disk From Virtual Drive"));
                 pEjectCurrentMedium->setEnabled(!m_pMediumIdHolder->isNull());
                 pEjectCurrentMedium->setIcon(iconPool()->icon(PixmapType_CDUnmountEnabled, PixmapType_CDUnmountDisabled));
@@ -3876,5 +3876,5 @@
                 /* Add "Choose a virtual floppy disk" action: */
                 addChooseExistingMediumAction(pOpenMediumMenu, tr("Choose/Create a Virtual Floppy Disk..."));
-                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a disk file..."));
+                addChooseDiskFileAction(pOpenMediumMenu, tr("Choose a Disk File..."));
                 /* Add "Choose a physical drive" actions: */
                 addChooseHostDriveActions(pOpenMediumMenu);
@@ -3884,5 +3884,5 @@
                 /* Add "Eject current medium" action: */
                 pOpenMediumMenu->addSeparator();
-                QAction *pEjectCurrentMedium = pOpenMediumMenu->addAction(tr("Remove Disk from Virtual Drive"));
+                QAction *pEjectCurrentMedium = pOpenMediumMenu->addAction(tr("Remove Disk From Virtual Drive"));
                 pEjectCurrentMedium->setEnabled(!m_pMediumIdHolder->isNull());
                 pEjectCurrentMedium->setIcon(iconPool()->icon(PixmapType_FDUnmountEnabled, PixmapType_FDUnmountDisabled));