Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMModePage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMModePage.cpp	(revision 105828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMModePage.cpp	(revision 105829)
@@ -73,8 +73,8 @@
     const QString strGeneral = UIWizardCloneVM::tr("<p>Please choose which parts of the snapshot tree "
                                                    "should be cloned with the machine.</p>");
-    const QString strOpt1    = UIWizardCloneVM::tr("<p>If you choose <b>Current machine state</b>, "
+    const QString strOpt1    = UIWizardCloneVM::tr("<p>If you choose <b>Current Machine State</b>, "
                                                    "the new machine will reflect the current state "
                                                    "of the original machine and will have no snapshots.</p>");
-    const QString strOpt2    = UIWizardCloneVM::tr("<p>If you choose <b>Current snapshot tree branch</b>, "
+    const QString strOpt2    = UIWizardCloneVM::tr("<p>If you choose <b>Current Snapshot Tree Branch</b>, "
                                                    "the new machine will reflect the current state "
                                                    "of the original machine and will have matching snapshots "
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMTypePage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMTypePage.cpp	(revision 105828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMTypePage.cpp	(revision 105829)
@@ -80,8 +80,8 @@
     /* Translate widgets: */
     QString strLabel = UIWizardCloneVM::tr("<p>Please choose the type of clone you wish to create.</p>"
-                                           "<p>If you choose <b>Full clone</b>, "
+                                           "<p>If you choose <b>Full Clone</b>, "
                                            "an exact copy (including all virtual hard disk files) "
                                            "of the original virtual machine will be created.</p>"
-                                           "<p>If you choose <b>Linked clone</b>, "
+                                           "<p>If you choose <b>Linked Clone</b>, "
                                            "a new machine will be created, but the virtual hard disk files "
                                            "will be tied to the virtual hard disk files of original machine "
@@ -89,5 +89,5 @@
                                            "to a different computer without moving the original as well.</p>");
     if (m_fAdditionalInfo)
-        strLabel += UIWizardCloneVM::tr("<p>If you create a <b>Linked clone</b> then a new snapshot will be created "
+        strLabel += UIWizardCloneVM::tr("<p>If you create a <b>Linked Clone</b> then a new snapshot will be created "
                                         "in the original virtual machine as part of the cloning process.</p>");
     if (m_pLabel)
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp	(revision 105828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp	(revision 105829)
@@ -498,10 +498,10 @@
     if (m_pFullCloneRadio)
     {
-        m_pFullCloneRadio->setText(UIWizardCloneVM::tr("&Full clone"));
+        m_pFullCloneRadio->setText(UIWizardCloneVM::tr("&Full Clone"));
         m_pFullCloneRadio->setToolTip(UIWizardCloneVM::tr("When chosen, all the virtual disks of the source vm are also cloned."));
     }
     if (m_pLinkedCloneRadio)
     {
-        m_pLinkedCloneRadio->setText(UIWizardCloneVM::tr("&Linked clone"));
+        m_pLinkedCloneRadio->setText(UIWizardCloneVM::tr("&Linked Clone"));
         m_pLinkedCloneRadio->setToolTip(UIWizardCloneVM::tr("When chosen, the cloned vm will save space by sharing the source VM's disk images."));
     }
@@ -569,9 +569,9 @@
     if (m_pMachineRadio)
     {
-        m_pMachineRadio->setText(UIWizardCloneVM::tr("Current &machine state"));
+        m_pMachineRadio->setText(UIWizardCloneVM::tr("Current &Machine State"));
         m_pMachineRadio->setToolTip(UIWizardCloneVM::tr("When chosen, only the current state of the source vm is cloned."));
     }
     if (m_pMachineAndChildsRadio)
-        m_pMachineAndChildsRadio->setText(UIWizardCloneVM::tr("Current &snapshot tree branch"));
+        m_pMachineAndChildsRadio->setText(UIWizardCloneVM::tr("Current &Snapshot Tree Branch"));
     if (m_pAllRadio)
     {