Index: trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompFuncs.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompFuncs.h	(revision 105853)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompFuncs.h	(revision 105854)
@@ -578,6 +578,4 @@
 
 #ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
-    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
-
     pReNative->Core.offPc += cbInstr;
     Log4(("offPc=%x cbInstr=%#x off=%#x\n", pReNative->Core.offPc, cbInstr, off));
@@ -588,10 +586,8 @@
     off = iemNativePcAdjustCheck(pReNative, off);
 # endif
-
-    if (pReNative->cCondDepth)
-        off = iemNativeEmitPcWriteback(pReNative, off);
-    else
-        pReNative->Core.cInstrPcUpdateSkipped++;
-
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
+    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
+    pReNative->Core.cInstrPcUpdateSkipped++;
+# endif
 #endif
 
@@ -631,6 +627,4 @@
 
 #ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
-    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
-
     pReNative->Core.offPc += cbInstr;
     Log4(("offPc=%x cbInstr=%#x off=%#x\n", pReNative->Core.offPc, cbInstr, off));
@@ -641,9 +635,8 @@
     off = iemNativePcAdjustCheck(pReNative, off);
 # endif
-
-    if (pReNative->cCondDepth)
-        off = iemNativeEmitPcWriteback(pReNative, off);
-    else
-        pReNative->Core.cInstrPcUpdateSkipped++;
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
+    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
+    pReNative->Core.cInstrPcUpdateSkipped++;
+# endif
 #endif
 
@@ -684,6 +677,4 @@
 
 #ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
-    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
-
     pReNative->Core.offPc += cbInstr;
     Log4(("offPc=%x cbInstr=%#x off=%#x\n", pReNative->Core.offPc, cbInstr, off));
@@ -694,9 +685,8 @@
     off = iemNativePcAdjustCheck(pReNative, off);
 # endif
-
-    if (pReNative->cCondDepth)
-        off = iemNativeEmitPcWriteback(pReNative, off);
-    else
-        pReNative->Core.cInstrPcUpdateSkipped++;
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
+    STAM_COUNTER_INC(&pReNative->pVCpu->iem.s.StatNativePcUpdateTotal);
+    pReNative->Core.cInstrPcUpdateSkipped++;
+# endif
 #endif
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp	(revision 105853)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp	(revision 105854)
@@ -2071,5 +2071,7 @@
 #ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
     pReNative->Core.offPc                  = 0;
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
     pReNative->Core.cInstrPcUpdateSkipped  = 0;
+# endif
 # ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING_DEBUG
     pReNative->Core.fDebugPcInitialized    = false;
@@ -5788,7 +5790,9 @@
 # endif
 
+    pReNative->Core.offPc                 = 0;
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
     STAM_COUNTER_ADD(&pReNative->pVCpu->iem.s.StatNativePcUpdateDelayed, pReNative->Core.cInstrPcUpdateSkipped);
-    pReNative->Core.offPc                 = 0;
     pReNative->Core.cInstrPcUpdateSkipped = 0;
+# endif
 
     return off;
Index: trunk/src/VBox/VMM/include/IEMN8veRecompiler.h
===================================================================
--- trunk/src/VBox/VMM/include/IEMN8veRecompiler.h	(revision 105853)
+++ trunk/src/VBox/VMM/include/IEMN8veRecompiler.h	(revision 105854)
@@ -1245,6 +1245,8 @@
      * as long as possible. */
     uint32_t                    offPc;
+# if defined(IEMNATIVE_WITH_TB_DEBUG_INFO) || defined(VBOX_WITH_STATISTICS)
     /** Number of instructions where we could skip the updating. */
     uint8_t                     cInstrPcUpdateSkipped;
+# endif
 # ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING_DEBUG
     /** Set after we've loaded PC into uPcUpdatingDebug at the first update. */